(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/core'), require('dayjs'), require('dayjs/plugin/utc'), require('dayjs/plugin/localeData'), require('dayjs/plugin/localizedFormat'), require('dayjs/plugin/customParseFormat')) :
    typeof define === 'function' && define.amd ? define('@tabuckner/material-dayjs-adapter', ['exports', '@angular/core', '@angular/material/core', 'dayjs', 'dayjs/plugin/utc', 'dayjs/plugin/localeData', 'dayjs/plugin/localizedFormat', 'dayjs/plugin/customParseFormat'], factory) :
    (global = global || self, factory((global.tabuckner = global.tabuckner || {}, global.tabuckner['material-dayjs-adapter'] = {}), global.ng.core, global.ng.material.core, global.dayjs, global.utc, global.localeData, global.LocalizedFormat, global.customParseFormat));
}(this, (function (exports, core, core$1, dayjs, utc, localeData, LocalizedFormat, customParseFormat) { 'use strict';

    dayjs = dayjs && Object.prototype.hasOwnProperty.call(dayjs, 'default') ? dayjs['default'] : dayjs;
    utc = utc && Object.prototype.hasOwnProperty.call(utc, 'default') ? utc['default'] : utc;
    localeData = localeData && Object.prototype.hasOwnProperty.call(localeData, 'default') ? localeData['default'] : localeData;
    LocalizedFormat = LocalizedFormat && Object.prototype.hasOwnProperty.call(LocalizedFormat, 'default') ? LocalizedFormat['default'] : LocalizedFormat;
    customParseFormat = customParseFormat && Object.prototype.hasOwnProperty.call(customParseFormat, 'default') ? customParseFormat['default'] : customParseFormat;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /** InjectionToken for Dayjs date adapter to configure options. */
    var MAT_DAYJS_DATE_ADAPTER_OPTIONS = new core.InjectionToken('MAT_DAYJS_DATE_ADAPTER_OPTIONS', {
        providedIn: 'root',
        factory: MAT_DAYJS_DATE_ADAPTER_OPTIONS_FACTORY
    });
    function MAT_DAYJS_DATE_ADAPTER_OPTIONS_FACTORY() {
        return {
            useUtc: false
        };
    }
    /** Creates an array and fills it with values. */
    function range(length, valueFunction) {
        var valuesArray = Array(length);
        for (var i = 0; i < length; i++) {
            valuesArray[i] = valueFunction(i);
        }
        return valuesArray;
    }
    /** Adapts Dayjs Dates for use with Angular Material. */
    var DayjsDateAdapter = /** @class */ (function (_super) {
        __extends(DayjsDateAdapter, _super);
        function DayjsDateAdapter(dateLocale, options) {
            var _this = _super.call(this) || this;
            _this.dateLocale = dateLocale;
            _this.options = options;
            _this.initializeParser(dateLocale);
            return _this;
        }
        // TODO: Implement
        DayjsDateAdapter.prototype.setLocale = function (locale) {
            var _this = this;
            _super.prototype.setLocale.call(this, locale);
            var dayJsLocaleData = this.dayJs().localeData();
            this.localeData = {
                firstDayOfWeek: dayJsLocaleData.firstDayOfWeek(),
                longMonths: dayJsLocaleData.months(),
                shortMonths: dayJsLocaleData.monthsShort(),
                dates: range(31, function (i) { return _this.createDate(2017, 0, i + 1).format('D'); }),
                longDaysOfWeek: range(7, function (i) { return _this.dayJs().set('day', i).format('dddd'); }),
                shortDaysOfWeek: dayJsLocaleData.weekdaysShort(),
                narrowDaysOfWeek: dayJsLocaleData.weekdaysMin(),
            };
        };
        DayjsDateAdapter.prototype.getYear = function (date) {
            return this.dayJs(date).year();
        };
        DayjsDateAdapter.prototype.getMonth = function (date) {
            return this.dayJs(date).month();
        };
        DayjsDateAdapter.prototype.getDate = function (date) {
            return this.dayJs(date).date();
        };
        DayjsDateAdapter.prototype.getDayOfWeek = function (date) {
            return this.dayJs(date).day();
        };
        DayjsDateAdapter.prototype.getMonthNames = function (style) {
            return style === 'long' ? this.localeData.longMonths : this.localeData.shortMonths;
        };
        DayjsDateAdapter.prototype.getDateNames = function () {
            return this.localeData.dates;
        };
        DayjsDateAdapter.prototype.getDayOfWeekNames = function (style) {
            if (style === 'long') {
                return this.localeData.longDaysOfWeek;
            }
            if (style === 'short') {
                return this.localeData.shortDaysOfWeek;
            }
            return this.localeData.narrowDaysOfWeek;
        };
        DayjsDateAdapter.prototype.getYearName = function (date) {
            return this.dayJs(date).format('YYYY');
        };
        DayjsDateAdapter.prototype.getFirstDayOfWeek = function () {
            return this.localeData.firstDayOfWeek;
        };
        DayjsDateAdapter.prototype.getNumDaysInMonth = function (date) {
            return this.dayJs(date).daysInMonth();
        };
        DayjsDateAdapter.prototype.clone = function (date) {
            return date.clone();
        };
        DayjsDateAdapter.prototype.createDate = function (year, month, date) {
            var returnDayjs = this.dayJs()
                .set('year', year)
                .set('month', month)
                .set('date', date);
            return returnDayjs;
        };
        DayjsDateAdapter.prototype.today = function () {
            return this.dayJs();
        };
        DayjsDateAdapter.prototype.parse = function (value, parseFormat) {
            if (value && typeof value === 'string') {
                return this.dayJs(value, dayjs().localeData().longDateFormat(parseFormat), this.locale);
            }
            return value ? this.dayJs(value).locale(this.locale) : null;
        };
        DayjsDateAdapter.prototype.format = function (date, displayFormat) {
            if (!this.isValid(date)) {
                throw Error('DayjsDateAdapter: Cannot format invalid date.');
            }
            return date.locale(this.locale).format(displayFormat);
        };
        DayjsDateAdapter.prototype.addCalendarYears = function (date, years) {
            return date.add(years, 'year');
        };
        DayjsDateAdapter.prototype.addCalendarMonths = function (date, months) {
            return date.add(months, 'month');
        };
        DayjsDateAdapter.prototype.addCalendarDays = function (date, days) {
            return date.add(days, 'day');
        };
        DayjsDateAdapter.prototype.toIso8601 = function (date) {
            return date.toISOString();
        };
        /**
         * Attempts to deserialize a value to a valid date object. This is different from parsing in that
         * deserialize should only accept non-ambiguous, locale-independent formats (e.g. a ISO 8601
         * string). The default implementation does not allow any deserialization, it simply checks that
         * the given value is already a valid date object or null. The `<mat-datepicker>` will call this
         * method on all of it's `@Input()` properties that accept dates. It is therefore possible to
         * support passing values from your backend directly to these properties by overriding this method
         * to also deserialize the format used by your backend.
         * @param value The value to be deserialized into a date object.
         * @returns The deserialized date object, either a valid date, null if the value can be
         *     deserialized into a null date (e.g. the empty string), or an invalid date.
         */
        DayjsDateAdapter.prototype.deserialize = function (value) {
            var date;
            if (value instanceof Date) {
                date = this.dayJs(value);
            }
            else if (this.isDateInstance(value)) {
                // NOTE: assumes that cloning also sets the correct locale.
                return this.clone(value);
            }
            if (typeof value === 'string') {
                if (!value) {
                    return null;
                }
                date = this.dayJs(value).toISOString();
            }
            if (date && this.isValid(date)) {
                return this.dayJs(date); // NOTE: Is this necessary since Dayjs is immutable and Moment was not?
            }
            return _super.prototype.deserialize.call(this, value);
        };
        DayjsDateAdapter.prototype.isDateInstance = function (obj) {
            return dayjs.isDayjs(obj);
        };
        DayjsDateAdapter.prototype.isValid = function (date) {
            return this.dayJs(date).isValid();
        };
        DayjsDateAdapter.prototype.invalid = function () {
            return this.dayJs(null);
        };
        DayjsDateAdapter.prototype.dayJs = function (input, format, locale) {
            if (!this.shouldUseUtc) {
                return dayjs(input, { format: format, locale: locale }, locale);
            }
            return dayjs(input, { format: format, locale: locale, utc: this.shouldUseUtc }, locale).utc();
        };
        Object.defineProperty(DayjsDateAdapter.prototype, "shouldUseUtc", {
            get: function () {
                var useUtc = (this.options || {}).useUtc;
                return !!useUtc;
            },
            enumerable: true,
            configurable: true
        });
        DayjsDateAdapter.prototype.initializeParser = function (dateLocale) {
            if (this.shouldUseUtc) {
                dayjs.extend(utc);
            }
            dayjs.extend(LocalizedFormat);
            dayjs.extend(customParseFormat);
            dayjs.extend(localeData);
            this.setLocale(dateLocale);
        };
        DayjsDateAdapter = __decorate([
            __param(0, core.Optional()), __param(0, core.Inject(core$1.MAT_DATE_LOCALE)),
            __param(1, core.Optional()), __param(1, core.Inject(MAT_DAYJS_DATE_ADAPTER_OPTIONS))
        ], DayjsDateAdapter);
        return DayjsDateAdapter;
    }(core$1.DateAdapter));

    /**
     * Custom Date-Formats and Adapter (using https://github.com/iamkun/dayjs)
     */
    var MAT_DAYJS_DATE_FORMATS = {
        parse: {
            dateInput: 'MM/DD/YYYY',
        },
        display: {
            dateInput: 'MM/DD/YYYY',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY',
        }
    };

    var DayjsDateModule = /** @class */ (function () {
        function DayjsDateModule() {
        }
        DayjsDateModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: core$1.DateAdapter,
                        useClass: DayjsDateAdapter,
                        deps: [core$1.MAT_DATE_LOCALE, MAT_DAYJS_DATE_ADAPTER_OPTIONS]
                    }
                ],
            })
        ], DayjsDateModule);
        return DayjsDateModule;
    }());
    var ɵ0 = MAT_DAYJS_DATE_FORMATS;
    var MatDayjsDateModule = /** @class */ (function () {
        function MatDayjsDateModule() {
        }
        MatDayjsDateModule = __decorate([
            core.NgModule({
                imports: [DayjsDateModule],
                providers: [{ provide: core$1.MAT_DATE_FORMATS, useValue: ɵ0 }],
            })
        ], MatDayjsDateModule);
        return MatDayjsDateModule;
    }());

    exports.DayjsDateModule = DayjsDateModule;
    exports.MAT_DAYJS_DATE_ADAPTER_OPTIONS = MAT_DAYJS_DATE_ADAPTER_OPTIONS;
    exports.MAT_DAYJS_DATE_FORMATS = MAT_DAYJS_DATE_FORMATS;
    exports.MatDayjsDateModule = MatDayjsDateModule;
    exports.ɵ0 = ɵ0;
    exports.ɵa = MAT_DAYJS_DATE_ADAPTER_OPTIONS_FACTORY;
    exports.ɵb = DayjsDateAdapter;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=tabuckner-material-dayjs-adapter.umd.js.map
